Imports Application = Intergraph.GeoMedia.GeoMedia.Application
Imports GDO1 = Intergraph.GeoMedia.GDO
Imports PClient = Intergraph.Geomedia.PClient

Imports GeoMedia = Intergraph.GeoMedia.GeoMedia
Imports PPipe = Intergraph.GeoMedia.PPipe
Imports GMMapView = Intergraph.GeoMedia.MapviewLib.GMMapView
Imports PView = Intergraph.GeoMedia.PView
Imports PDBpipe = Intergraph.GeoMedia.PDBPipe
Imports GMService = Intergraph.GeoMedia.GMService
Imports Maths = System.Math


Public Class Simulador

    '****************************************************************************'
    '**************** 										 ********************'	
    '****************          APLICACI DE SIMULACI        ********************'
    '**************** 										 ********************'
    '****************************************************************************'

    '****************************************************************************'
    '************************** SIMULADOR DE PERSONES ***************************'
    '****************************************************************************'

    'Variables de l'aplicaci de simulaci
    Dim GeoAppSim As Application
    Dim objDoc As GeoMedia.Document
    Dim GMMapViewSim As New GMMapView
    Dim objOPipe As PClient.OriginatingPipe
    Dim objDBSim As GDO1.GDatabase
    Dim frmMonitor As New frmMonitor

    'Constructor pblic
    Public Sub New()
    End Sub

    'Funci que obre la connexi a BBDD
    Private Sub OpenDDBBSim()
        'Connexi a BBDD
        Try
            objDBSim = CreateObject("Access.GDatabase")
            objDBSim.OpenDatabase("C:\Warehouses\TFCMonitorRCollados.mdb")
            objDBSim.BeginTrans()
        Catch ex As Exception
            MsgBox("Es necessita el fitxer de base de dades a C:\Warehouses\TFCMonitorRCollados.mdb")
        End Try

    End Sub

    'Funci que tanca la connexi a BBDD
    Private Sub CloseDDBBSim()
        Try
            objDBSim.CommitTrans()
            objDBSim.Close()
            objDBSim = Nothing
        Catch ex As Exception
            objDBSim.Rollback()
            objDBSim.Close()
            objDBSim = Nothing
            MsgBox("Error al accedir a la de base de dades a C:\Warehouses\TFCMonitorRCollados.mdb")
        End Try
    End Sub

    'Funci que mou a la persona pel mapa
    Public Sub MovePersona()
        'Declaraci variables
        Dim objRS As GDO1.GRecordset

        Me.OpenDDBBSim()
        'Consulta
        objRS = objDBSim.OpenRecordset("SELECT * FROM POSPERSONA", GDO1.GConstants.gdbOpenDynaset)
        Randomize()

        'Recuperam la localitzaci de la persona relacionada amb la taula Parcela que cont les coordenades
        objRS.MoveLast() : objRS.MoveFirst()
        Do While Not objRS.EOF
            objRS.Edit()
            'Dim aux = objRS.GFields("COORDX").Value
            'objRS.GFields("COORDX").Value = aux + 2

            If objRS.GFields("TOKENS").Value = 0 Then 'Si no queden pases a donar es tornar a escollir nmero de pases i sentit
                objRS.GFields("TOKENS").Value = Int((60 * Rnd()) + 1) 'Nmero de pases consecutives en la mateixa direcci
                objRS.GFields("SENTIT").Value = Int((5 * Rnd()) + 1) '1 = Cap a dalt; 2 = Cap a la dreta; 3 = Cap a baix; 4 = Cap a l'esquerra; 5 Aturat
                objRS.GFields("TEMPS_ATURAT").Value = 0
            End If

            If objRS.GFields("SENTIT").Value = 1 Then
                objRS.GFields("COORDY").Value = objRS.GFields("COORDY").Value + 2
            ElseIf objRS.GFields("SENTIT").Value = 2 Then
                objRS.GFields("COORDX").Value = objRS.GFields("COORDX").Value + 2
            ElseIf objRS.GFields("SENTIT").Value = 3 Then
                objRS.GFields("COORDY").Value = objRS.GFields("COORDY").Value - 2
            ElseIf objRS.GFields("SENTIT").Value = 4 Then
                objRS.GFields("COORDX").Value = objRS.GFields("COORDX").Value - 2
            ElseIf objRS.GFields("SENTIT").Value = 5 Then
                objRS.GFields("TEMPS_ATURAT").Value = objRS.GFields("TEMPS_ATURAT").Value + 1
            Else
                MsgBox("Error: Inconsistncia a la BBDD")
            End If

            'Control de temps atural
            If objRS.GFields("TEMPS_ATURAT").Value = 30 Or objRS.GFields("TEMPS_ATURAT").Value = 40 Or objRS.GFields("TEMPS_ATURAT").Value = 50 Then
                frmMonitor.ListBox1.Items.Add(objRS.GFields("NOMPERSONA").Value & " no s'ha mogut de casa des de fa " & objRS.GFields("TEMPS_ATURAT").Value & " hores")
                frmMonitor.ListBox1.SelectedIndex = frmMonitor.ListBox1.Items.Count - 1
            End If

            objRS.GFields("TOKENS").Value = objRS.GFields("TOKENS").Value - 1
            objRS.Update()
            objRS.MoveNext()

        Loop

        objRS.Close()
        Me.CloseDDBBSim()

        objRS = Nothing

    End Sub

    Public Sub LoadEntryPersona()
        GeoAppSim = GetObject(, "Geomedia.Application")
        GMMapViewSim = GeoAppSim.ActiveWindow.MapView
        Dim objConnPers As PClient.Connection
        objConnPers = GeoAppSim.Document.Connections.Item("TFCConnection")

        objConnPers.CreateOriginatingPipe(objOPipe)
        objOPipe.GeometryFieldName = "GEOMETRY"
        objOPipe.Table = "POSPERSONA"
        objOPipe.Filter = "MOSTRAR = 1"

        ' Create and define the record legend entry
        Dim objRLE As PView.LegendEntry
        objRLE = GeoAppSim.CreateService("Geomedia.LegendEntry")

        Dim objStyleService As New PView.StyleService
        Dim objstyle1 As PView.StyleDefinition = Nothing
        objStyleService.GetStyle("Symbol Style", objstyle1)
        objstyle1.StyleProperties(PView.StylePropertyConstants.gmgroPropertyOverrideColor).Value = RGB(220, 0, 0)
        objstyle1.StyleProperties(PView.StylePropertyConstants.gmgroPropertySize).Value = "352"

        Dim objproperty As New PDBpipe.GMProperty
        objproperty.Name = "Title"
        objproperty.Value = " PERSONES"
        GMMapViewSim.Legend.LegendEntries.Remove(1)

        Dim objCGP As New GMService.CoordGeocodePipe
        With objCGP
            .CoordSystem = GMMapViewSim.CoordSystemsMgr.CoordSystem
            .InputRecordset = objOPipe.OutputRecordset
            .InputFirstCoordFieldName = "COORDX"
            .InputSecondCoordFieldName = "COORDY"
            .OutputGeometryFieldName = "OutGeometry"
            .OutputStatusFieldName = "OutStatus"
        End With

        GMMapViewSim.Legend.LegendEntries.Append(objRLE, 1)
        With GMMapViewSim.Legend.LegendEntries.Item(1)
            .InputRecordset = objCGP.OutputRecordset
            .GeometryFieldName = "OutGeometry"
            .Style = objstyle1
            .PropertySet.Append(objproperty)
        End With

        'Declaraci variables
        Dim objRSGeo As GDO1.GRecordset

        Me.OpenDDBBSim()

        objRSGeo = objDBSim.OpenRecordset("SELECT * FROM POSPERSONA", GDO1.GConstants.gdbOpenDynaset)
        objCGP.OutputRecordset.MoveLast() : objCGP.OutputRecordset.MoveFirst()
        Do While Not objCGP.OutputRecordset.EOF
            objRSGeo.MoveLast() : objRSGeo.MoveFirst()
            Do While Not objRSGeo.EOF
                objRSGeo.Edit()
                If objRSGeo.GFields("IDPERSONA").Value = objCGP.OutputRecordset.GFields("IDPERSONA").Value Then
                    Dim outGeo = objCGP.OutputRecordset.GFields("OutGeometry").Value
                    objRSGeo.GFields("GEOMETRY").Value = outGeo
                End If
                objRSGeo.Update()
                objRSGeo.MoveNext()
            Loop
            objCGP.OutputRecordset.MoveNext()
        Loop

        objRSGeo.Close()
        Me.CloseDDBBSim()

        objRSGeo = Nothing

        GMMapViewSim.Legend.Visible = True

        objRLE.LoadData()
        GMMapViewSim.Refresh()

        objRLE = Nothing
        objCGP = Nothing
        objStyleService = Nothing
        objstyle1 = Nothing
        objproperty = Nothing
        GeoAppSim = Nothing
        GMMapViewSim = Nothing
    End Sub


End Class
