Option Explicit On

Imports Application = Intergraph.GeoMedia.GeoMedia.Application
Imports GDO1 = Intergraph.GeoMedia.GDO
Imports PClient = Intergraph.Geomedia.PClient
Imports PBasic = Intergraph.GeoMedia.PBasic
Imports GeoMedia = Intergraph.GeoMedia.GeoMedia
Imports PPipe = Intergraph.GeoMedia.PPipe
Imports GMMapView = Intergraph.GeoMedia.MapviewLib.GMMapView
Imports MapWindow = Intergraph.GeoMedia.GeoMedia.MapWindow
Imports PView = Intergraph.GeoMedia.PView
Imports PDBpipe = Intergraph.GeoMedia.PDBPipe
Imports PCSS = Intergraph.GeoMedia.PCSS
Imports GMService = Intergraph.GeoMedia.GMService
Imports Maths = System.Math
'Imports EventControl = Inter	graph.GeoMedia.GMEventControlLib
'Imports GMLayout = Intergraph.GeoMedia.GMLayout
'Imports AxEvents = AxIntergraph.GeoMedia.GMEventControlLib

Public Class frmMonitor

    'Declarem variables GLOBALS
    Dim GeoApp As Application
    Dim objDoc As GeoMedia.Document
    Dim GMMapView1, GMMapViewZoom As New GMMapView
    Dim MapWindow1 As MapWindow
    Dim SimOn As Boolean
    Dim checks As Integer = 1
    Dim sim As Simulador

    'Integers
    Dim refreshInterval As Integer

    Private Sub frmMonitor_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        GeoApp = GetObject(, "Geomedia.Application")
        MapWindow1 = GeoApp.ActiveWindow
        GMMapView1 = MapWindow1.MapView
		
		If GeoApp.Windows.Count = 0 Then
            MsgBox("No GeoWorkspace loaded. Creating new GeoWorkspace")
            objDoc = GeoApp.New
            GeoApp.Document.SaveAs("C:\temp\myfile.gws")
        Else
            objDoc = GeoApp.Document
        End If

        With MapWindow1
            .LegendViewPosition = GeoMedia.LegendViewPositionConstants.gmmwLegendViewPositionLeft
        End With

        Try
            With GMMapView1
                .CoordSystemsMgr = New PCSS.CoordSystemsMgr
                .CoordSystemsMgr.CoordSystem.LoadFromFile("C:\Warehouses\CSFRCollados.csf")
                .PreserveMapScaleWhenResizing = True
                .LocateTolerance = 7
                .ZoomFactor = 0.5
                .ZoomArea(477961.64, 4364152.35, 0, 479077.64, 4364831.86, 0)
            End With
        Catch ex As Exception
            MsgBox("Es necessita el fitxer de sistemes de coordenades a C:\GeoWorkspaces\CSFRCollados.csf")
        End Try

        GeoApp.Visible = True
        GeoApp.StatusBarVisible = True


        Me.InitConnectionBBDD()
        Me.InitLegendEntries()
        Me.InitPersona()
        Me.InitRestriccions()
        objDoc.RefreshViews()

        SimOn = False
        checks = 0
        GroupBox2.Hide()
        GroupBox4.Hide()
        StopButton.Hide()
    End Sub

    '****************************************************************************'
    '**************** FUNCIONALITAT DELS BOTONS DEL FORMULARI *******************'
    '****************************************************************************'

    Private Sub NumericUpDown_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDown1.ValueChanged
        refreshInterval = NumericUpDown1.Value * 1000
    End Sub

    Private Sub InitButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles InitButton.Click
        Timer1.Enabled = True
        SimOn = True
        NumericUpDown1.Hide()
        Label1.Hide()
        InitButton.Hide()
        StopButton.Show()
        GroupBox2.Show()
        GroupBox4.Show()
        GroupBox3.Hide()
        checks = 1
    End Sub

    Private Sub StopButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StopButton.Click
        'Timer1.Enabled = False
        SimOn = False
        NumericUpDown1.Show()
        Label1.Show()
        InitButton.Show()
        StopButton.Hide()
        GroupBox2.Hide()
        GroupBox4.Hide()
        GroupBox3.Show()
        checks = 0
        ListBox1.Items.Clear()
    End Sub


    Private Sub ZoomIn_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ZoomIn.Click
        GeoApp = GetObject(, "Geomedia.Application")
        GMMapViewZoom = GeoApp.ActiveWindow.MapView
        GMMapViewZoom.Zoom(True, True, 1, 1, 1)
        GMMapViewZoom.Refresh()
    End Sub

    Private Sub ZoomOut_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ZoomOut.Click
        GeoApp = GetObject(, "Geomedia.Application")
        GMMapViewZoom = GeoApp.ActiveWindow.MapView
        GMMapView1.Zoom(False, True, 1, 1, 1)
        GMMapViewZoom.Refresh()
    End Sub

    Private Sub CheckBox1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox1.CheckedChanged
        If checks = 0 Then
            MostrarPersona(1, CheckBox1)
        End If
    End Sub

    Private Sub CheckBox2_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox2.CheckedChanged
        If checks = 0 Then
            MostrarPersona(2, CheckBox2)
        End If
    End Sub

    Private Sub CheckBox3_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox3.CheckedChanged
        If checks = 0 Then
            MostrarPersona(3, CheckBox3)
        End If
    End Sub

    Private Sub CheckBox4_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox4.CheckedChanged
        If checks = 0 Then
            MostrarPersona(4, CheckBox4)
        End If
    End Sub

    Private Sub CheckBox5_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox5.CheckedChanged
        If checks = 0 Then
            MostrarPersona(5, CheckBox5)
        End If
    End Sub

    Private Sub CheckBox6_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox6.CheckedChanged
        If checks = 0 Then
            MostrarPersona(6, CheckBox6)
        End If
    End Sub

    Private Sub CheckBox7_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox7.CheckedChanged
        If checks = 0 Then
            MostrarPersona(7, CheckBox7)
        End If
    End Sub

    Private Sub CheckBox8_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox8.CheckedChanged
        If checks = 0 Then
            MostrarPersona(8, CheckBox8)
        End If
    End Sub

    Private Sub CheckBox9_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox9.CheckedChanged
        If checks = 0 Then
            MostrarPersona(9, CheckBox9)
        End If
    End Sub

    Private Sub CheckBox10_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox10.CheckedChanged
        If checks = 0 Then
            MostrarPersona(10, CheckBox10)
        End If
    End Sub

    Private Sub CheckBox11_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox11.CheckedChanged
        If checks = 0 Then
            MostrarPersona(11, CheckBox11)
        End If
    End Sub

    Private Sub CheckBox12_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox12.CheckedChanged
        If checks = 0 Then
            MostrarPersona(12, CheckBox12)
        End If
    End Sub

    Private Sub CheckBox13_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox13.CheckedChanged
        If checks = 0 Then
            MostrarPersona(13, CheckBox13)
        End If
    End Sub

    Private Sub CheckBox14_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox14.CheckedChanged
        If checks = 0 Then
            MostrarPersona(14, CheckBox14)
        End If
    End Sub

    Private Sub CheckBox15_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox15.CheckedChanged
        If checks = 0 Then
            MostrarPersona(15, CheckBox15)
        End If
    End Sub

    Private Sub CheckBox16_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox16.CheckedChanged
        If checks = 0 Then
            MostrarPersona(16, CheckBox16)
        End If
    End Sub

    Private Sub CheckBox17_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox17.CheckedChanged
        If checks = 0 Then
            MostrarPersona(17, CheckBox17)
        End If
    End Sub

    Private Sub CheckBox18_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox18.CheckedChanged
        If checks = 0 Then
            MostrarPersona(18, CheckBox18)
        End If
    End Sub

    Private Sub CheckBox19_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox19.CheckedChanged
        If checks = 0 Then
            MostrarPersona(19, CheckBox19)
        End If

    End Sub

    Private Sub CheckBox20_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox20.CheckedChanged
        If checks = 0 Then
            MostrarPersona(20, CheckBox20)
        End If
    End Sub

    Private Sub frmMonitor_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed
        Dim response As MsgBoxResult
        Dim title As Object
        title = "Sortir"
        response = MsgBox("Segur que voleu tancar l'aplicaci?", MsgBoxStyle.YesNo, title)
        If response = MsgBoxResult.Yes Then
            Timer1.Dispose()
            Timer1.Stop()
            Me.Close()
            sim = Nothing
            GeoApp = Nothing
            objDoc = Nothing
            GMMapView1 = Nothing
            MapWindow1 = Nothing
            objConn = Nothing
            GC.Collect()
            GC.WaitForPendingFinalizers()
        Else
            Me.Show()
        End If
    End Sub
	
	'****************************************************************************'
    '************************** CONTROLADOR DE TEMPS ****************************'
    '****************************************************************************'

    'Funci que controla els events que s'han de produir cada x interval de temps.
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Timer1.Interval = refreshInterval
        If SimOn Then
            sim = New Simulador()
            sim.MovePersona()
            sim.LoadEntryPersona()
            Me.ComprovarRestriccions()
        End If
    End Sub


	'****************************************************************************'
    '**************** 										 ********************'	
    '****************       APLICACI DE MONITORITZACI      ********************'
	'**************** 										 ********************'
    '****************************************************************************'
	
    '****************************************************************************'
    '**************** FUNCIONALITATS DE INICI DE LA APLICACI *******************'
    '****************************************************************************'
	
	'Variables de l'aplicaci de monitoritzaci
	Dim objConn As New PClient.Connection
    Dim objDB As GDO1.GDatabase
	
	'Arrays de noms CONSTANTS
    Dim LegendNames As String() = {"PERSONA", "PARCELA", "CONSTRU", "LIMITES", "MASA", "SUBPARCE", "MapaPnoa"}
    Dim GeometryNames As String() = {"Geometry", "Geometry", "Geometry", "Geometry", "Geometry", "Geometry", "Geometra"}
    Dim StyleNames As String() = {"Symbol Style", "Area Style", "Area Style", "Simple Line Style", "Area Style", "Area Style", "Image Style"}

    'Funci que crea connexi a base de dades
    Private Sub InitConnectionBBDD()
        objConn = GeoApp.CreateService("GeoMedia.Connection")
        Try
            With objConn
                .Name = "TFCConnection"
                .Type = "Access.GDatabase"
                .Location = "C:\Warehouses\TFCMonitorRCollados.mdb"
                .Connect()
            End With
            GeoApp.Document.Connections.Append(objConn)
        Catch ex As Exception
            MsgBox("Es necessita el fitxer de base de dades a C:\Warehouses\TFCMonitorRCollados.mdb")
        End Try
        
    End Sub

    'Funci que obre la connexi a BBDD
    Private Sub OpenDDBB()
        'Connexi a BBDD
        Try
            objDB = CreateObject("Access.GDatabase")
            objDB.OpenDatabase("C:\Warehouses\TFCMonitorRCollados.mdb")
            objDB.BeginTrans()
        Catch ex As Exception
            MsgBox("Es necessita el fitxer de base de dades a C:\Warehouses\TFCMonitorRCollados.mdb")
        End Try

    End Sub

    'Funci que tanca la connexi a BBDD
    Private Sub CloseDDBB()
        Try
            objDB.CommitTrans()
            objDB.Close()
            objDB = Nothing
        Catch ex As Exception
            objDB.Rollback()
            objDB.Close()
            objDB = Nothing
            MsgBox("Error al accedir a la de base de dades a C:\Warehouses\TFCMonitorRCollados.mdb")
        End Try
    End Sub

    'Funci que carrega les entrades a llegenda necessries per la visualitzaci del mapa
    Private Sub InitLegendEntries()
        Dim i As New Integer
        Dim objConnLE As New PClient.Connection

        objConnLE = GeoApp.Document.Connections.Item("TFCConnection")

        For i = 1 To 7
            Me.LoadLegendEntry(objConnLE, i)
        Next

        i = Nothing
        objConnLE = Nothing
    End Sub

    'Funci que reinicia els valors de les persones del mapa, situant-los a la posisi inicial.
    Public Sub InitPersona()
        'Declaraci variables
        Dim objRS, objRS2 As GDO1.GRecordset

        Me.OpenDDBB()

        'Consulta
        objRS = objDB.OpenRecordset("SELECT * FROM PERSONA AS P, PARCELA AS L WHERE P.IDLOC = L.ID1", GDO1.GConstants.gdbOpenDynaset)
        objRS2 = objDB.OpenRecordset("SELECT * FROM POSPERSONA", GDO1.GConstants.gdbOpenDynaset)

        'Recuperam la localitzaci de la persona relacionada amb la taula Parcela que cont les coordenades
        objRS.MoveLast() : objRS.MoveFirst()
        Do While Not objRS.EOF
            objRS2.MoveLast() : objRS2.MoveFirst()
            Do While Not objRS2.EOF
                objRS2.Edit()
                If objRS.GFields("IDPERSONA").Value = objRS2.GFields("IDPERSONA").Value Then
                    Dim cX = objRS.GFields("COORX").Value
                    Dim cY = objRS.GFields("COORY").Value
                    Dim nom = objRS.GFields("NOMPERSONA").Value
                    'Dim geo = objRS.GFields("Geometry1").Value
                    objRS2.GFields("COORDX").Value = cX
                    objRS2.GFields("COORDY").Value = cY
                    objRS2.GFields("NOMPERSONA").Value = nom
                    objRS2.GFields("GEOMETRY").Value = System.DBNull.Value
                    objRS2.GFields("TOKENS").Value = 0
                    objRS2.GFields("TEMPS_ATURAT").Value = 0
                    objRS2.GFields("MOSTRAR").Value = 1
                End If
                objRS2.Update()
                objRS2.MoveNext()
            Loop
            objRS.MoveNext()
        Loop

        Me.CloseDDBB()

        objRS = Nothing
        objRS2 = Nothing
    End Sub

    'Funci que reinicia els flags de la taula de restriccions.
    Private Sub InitRestriccions()
        Dim objRST As GDO1.GRecordset
        Dim objConnRST As New PClient.Connection
        objConnRST = GeoApp.Document.Connections.Item("TFCConnection")

        Me.OpenDDBB()

        objRST = objDB.OpenRecordset("SELECT * FROM RESTRICCIONS", GDO1.GConstants.gdbOpenDynaset)
        objRST.MoveLast() : objRST.MoveFirst()

        Do While Not objRST.EOF
            objRST.Edit()
            objRST.GFields("FLAG").Value = 0
            objRST.Update()
            objRST.MoveNext()
        Loop

        Me.CloseDDBB()

        objRST = Nothing
        objConnRST = Nothing
    End Sub

    'Funci que carrega una entrada de llegenda al cuadre de llegenda del mapa
    Private Sub LoadLegendEntry(ByVal objConnLE As PClient.Connection, ByVal pIndex As Integer)
        Dim objOPipeLE As PClient.OriginatingPipe
        objConnLE.CreateOriginatingPipe(objOPipeLE)
        objOPipeLE.GeometryFieldName = GeometryNames(pIndex - 1)
        objOPipeLE.Table = LegendNames(pIndex - 1)

        ' Create and define the record legend entry
        Dim objLoadRLE As PView.LegendEntry
        objLoadRLE = GeoApp.CreateService("Geomedia.LegendEntry")

        Dim objStyleService As New PView.StyleService
        Dim objstyle1 As PView.StyleDefinition = Me.LegendEntriesStyle(pIndex)

        Dim objproperty As New PDBpipe.GMProperty
        objproperty.Name = "Title"
        objproperty.Value = LegendNames(pIndex - 1)

        GMMapView1.Legend.LegendEntries.Append(objLoadRLE)

        With GMMapView1.Legend.LegendEntries.Item(pIndex)
            .InputRecordset = objOPipeLE.OutputRecordset
            .GeometryFieldName = GeometryNames(pIndex - 1)
            .Style = objstyle1
            .PropertySet.Append(objproperty)
        End With

        GMMapView1.Legend.Visible = True

        objLoadRLE.LoadData()

        objLoadRLE = Nothing
        objOPipeLE = Nothing
        objStyleService = Nothing
        objstyle1 = Nothing
        objproperty = Nothing
    End Sub

    'Funci que carrega el estil a la entrada de llegenda corresponent
    Function LegendEntriesStyle(ByVal pIndex As Integer) As PView.StyleDefinition
        Dim objStyleService As New PView.StyleService
        Dim objstyle As PView.StyleDefinition = Nothing
        objStyleService.GetStyle(StyleNames(pIndex - 1), objstyle)
        Select Case pIndex
            Case 1
                objstyle.StyleProperties(PView.StylePropertyConstants.gmgroPropertyOverrideColor).Value = RGB(0, 0, 220)
                objstyle.StyleProperties(PView.StylePropertyConstants.gmgroPropertySize).Value = "352"
            Case 2
                Dim objstyleB As PView.StyleDefinition
                objstyleB = objstyle.StyleDefinitions(0).StyleDefinitions(0)
                objstyleB.StyleProperties(PView.StylePropertyConstants.gmgroPropertyWidth).Value = 35
                objstyleB.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(200, 0, 100)
                Dim objstyleF = objstyle.StyleDefinitions(1).StyleDefinitions(0)
                objstyleF.StyleProperties(PView.StylePropertyConstants.gmgroPropertyTranslucency).Value = 100
            Case 3
                Dim objstyleB As PView.StyleDefinition
                objstyleB = objstyle.StyleDefinitions(0).StyleDefinitions(0)
                objstyleB.StyleProperties(PView.StylePropertyConstants.gmgroPropertyWidth).Value = 35
                objstyleB.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(150, 100, 50)
                Dim objstyleF = objstyle.StyleDefinitions(1).StyleDefinitions(0)
                objstyleF.StyleProperties(PView.StylePropertyConstants.gmgroPropertyTranslucency).Value = 100
            Case 4
                'NoStyle
            Case 5
                Dim objstyleB As PView.StyleDefinition
                objstyleB = objstyle.StyleDefinitions(0).StyleDefinitions(0)
                objstyleB.StyleProperties(PView.StylePropertyConstants.gmgroPropertyWidth).Value = 35
                objstyleB.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(0, 0, 100)
                Dim objstyleF = objstyle.StyleDefinitions(1).StyleDefinitions(0)
                objstyleF.StyleProperties(PView.StylePropertyConstants.gmgroPropertyTranslucency).Value = 100
            Case 6
                Dim objstyleB As PView.StyleDefinition
                objstyleB = objstyle.StyleDefinitions(0).StyleDefinitions(0)
                objstyleB.StyleProperties(PView.StylePropertyConstants.gmgroPropertyWidth).Value = 35
                objstyleB.StyleProperties(PView.StylePropertyConstants.gmgroPropertyColor).Value = RGB(50, 100, 0)
                Dim objstyleF = objstyle.StyleDefinitions(1).StyleDefinitions(0)
                objstyleF.StyleProperties(PView.StylePropertyConstants.gmgroPropertyTranslucency).Value = 100
            Case 7
                objstyle.StyleProperties(PView.StylePropertyConstants.gmgroPropertyTranslucency).Value = 70
        End Select
        Return objstyle
    End Function

    Private Sub MostrarPersona(ByVal id As Integer, ByVal CheckBox As Object)
        Me.OpenDDBB()
        Dim objRS As GDO1.GRecordset
        objRS = objDB.OpenRecordset("SELECT * FROM POSPERSONA WHERE IDPERSONA = " & id, GDO1.GConstants.gdbOpenDynaset)
        If CheckBox.Checked Then
            If objRS.GFields("MOSTRAR").Value <> 1 Then
                objRS.Edit()
                objRS.GFields("MOSTRAR").Value = 1
                objRS.Update()
            End If
        Else
            If objRS.GFields("MOSTRAR").Value <> 0 Then
                objRS.Edit()
                objRS.GFields("MOSTRAR").Value = 0
                objRS.Update()
            End If
        End If
        objRS = Nothing
        Me.CloseDDBB()
    End Sub

    '****************************************************************************'
    '*********************** COMPROVACI DE RESTRICCIONS ************************'
    '****************************************************************************'

    Sub ComprovarRestriccions()

        'CONTROL DE RESTRICCIONS
        '   1 - Persones a menys de x metres de distncia
        '   2 - Persona a menys de x metres de distncia d'una parcella
        '   3 - Persona surt de parcella
        '   4 - Persona entra a parcella

        Dim objRS1 As GDO1.GRecordset
        Dim objConnRST As New PClient.Connection
        'objConnRST = GeoApp.Document.Connections.Item("TFCConnection")

        Me.OpenDDBB()

        objRS1 = objDB.OpenRecordset("SELECT * FROM RESTRICCIONS", GDO1.GConstants.gdbOpenDynaset)
        Do While Not objRS1.EOF
            Dim objRS2, objRS3 As GDO1.GRecordset
            'Consulta vlida per tots els casos
            objRS3 = objDB.OpenRecordset("SELECT * FROM POSPERSONA WHERE IDPERSONA = " & objRS1.GFields("IDPERSONA").Value, GDO1.GConstants.gdbOpenDynaset)
            'Dades pel control 1
            'Control de tipus de restricci 1
            If objRS1.GFields("TIPUS").Value = 1 And objRS1.GFields("FLAG").Value = 0 Then
                objRS2 = objDB.OpenRecordset("SELECT * FROM POSPERSONA WHERE IDPERSONA = " & objRS1.GFields("IDOBJECTE").Value, GDO1.GConstants.gdbOpenDynaset)
                Dim puntAx, puntAy, puntBx, puntBy, metres, distancia As Double
                puntAx = objRS3.GFields("COORDX").Value
                puntAy = objRS3.GFields("COORDY").Value
                puntBx = objRS2.GFields("COORDX").Value
                puntBy = objRS2.GFields("COORDY").Value
                metres = objRS1.GFields("METRES").Value
                distancia = Maths.Sqrt(((puntBx - puntAx) ^ 2) + ((puntBy - puntAy) ^ 2))
                If distancia < metres Then
                    ListBox1.Items.Add(objRS3.GFields("NOMPERSONA").Value & " est a menys de " & metres & " metres de " & objRS2.GFields("NOMPERSONA").Value & " sense perms [" & Maths.Round(distancia) & "metres]")
                    ListBox1.SelectedIndex = ListBox1.Items.Count - 1
                End If
                puntAx = Nothing
                puntBx = Nothing
                puntAy = Nothing
                puntBy = Nothing
                metres = Nothing
                distancia = Nothing
            End If
            'Fi de control de tipus de restricci 1
            'Dades pels controls 2, 3 i 4
            objRS2 = objDB.OpenRecordset("SELECT * FROM PARCELA WHERE ID1 = " & objRS1.GFields("IDOBJECTE").Value, GDO1.GConstants.gdbOpenDynaset)
            'Control de tipus de restricci 2
            If objRS1.GFields("TIPUS").Value = 2 And objRS1.GFields("FLAG").Value = 0 Then
                Dim puntAx, puntAy, puntBx, puntBy, metres, distancia As Double
                puntAx = objRS3.GFields("COORDX").Value
                puntAy = objRS3.GFields("COORDY").Value
                puntBx = objRS2.GFields("COORX").Value
                puntBy = objRS2.GFields("COORY").Value
                metres = objRS1.GFields("METRES").Value
                distancia = Maths.Sqrt(((puntBx - puntAx) ^ 2) + ((puntBy - puntAy) ^ 2))
                If distancia < metres Then
                    ListBox1.Items.Add(objRS3.GFields("NOMPERSONA").Value & " est a menys de " & metres & " metres de " & objRS2.GFields("ID1").Value & " sense perms [" & Maths.Round(distancia) & "metres]")
                    ListBox1.SelectedIndex = ListBox1.Items.Count - 1
                End If
                puntAx = Nothing
                puntBx = Nothing
                puntAy = Nothing
                puntBy = Nothing
                metres = Nothing
                distancia = Nothing
            End If
            'Fi de control de tipus de restricci 2 
            Dim margeXdrt, margeXesq, margeYdlt, margeYbai As Integer
            margeXdrt = objRS2.GFields("COORX").Value + 15
            margeXesq = objRS2.GFields("COORX").Value - 15
            margeYdlt = objRS2.GFields("COORY").Value + 15
            margeYbai = objRS2.GFields("COORY").Value - 15
            'Control de tipus de restricci 3
            If objRS1.GFields("TIPUS").Value = 3 And objRS1.GFields("FLAG").Value = 0 Then
                If (margeXdrt < objRS3.GFields("COORDX").Value) Or (margeXesq > objRS3.GFields("COORDX").Value) Then
                    ListBox1.Items.Add(objRS3.GFields("NOMPERSONA").Value & " ha sortit de la parcella " & objRS2.GFields("ID1").Value & " sense perms")
                    ListBox1.SelectedIndex = ListBox1.Items.Count - 1
                    objRS1.Edit()
                    objRS1.GFields("FLAG").Value = 1
                    objRS1.Update()
                ElseIf (margeYdlt < objRS3.GFields("COORDY").Value) Or (margeYbai > objRS3.GFields("COORDY").Value) Then
                    ListBox1.Items.Add(objRS3.GFields("NOMPERSONA").Value & " ha sortit de la parcella " & objRS2.GFields("ID1").Value & " sense perms")
                    ListBox1.SelectedIndex = ListBox1.Items.Count - 1
                    objRS1.Edit()
                    objRS1.GFields("FLAG").Value = 1
                    objRS1.Update()
                End If
            End If
            'Fi control de tipus de restricci 3
            'Control de tipus de restricci 4
            If objRS1.GFields("TIPUS").Value = 4 And objRS1.GFields("FLAG").Value = 0 Then
                If (margeXesq < objRS3.GFields("COORDX").Value) And (objRS3.GFields("COORDX").Value < margeXdrt) And (margeYdlt > objRS3.GFields("COORDY").Value) And (margeYbai < objRS3.GFields("COORDY").Value) Then
                    ListBox1.Items.Add(objRS3.GFields("NOMPERSONA").Value & " ha entrat a la  parcella restringida " & objRS2.GFields("ID1").Value)
                    ListBox1.SelectedIndex = ListBox1.Items.Count - 1
                    objRS1.Edit()
                    objRS1.GFields("FLAG").Value = 1
                    objRS1.Update()
                End If
            End If
            'Fi de control de tipus de restricci 
            margeXdrt = Nothing
            margeXesq = Nothing
            margeYdlt = Nothing
            margeYbai = Nothing
            objRS2 = Nothing
            objRS3 = Nothing
            objRS1.MoveNext()
        Loop

        Me.CloseDDBB()

        'objConnRST = Nothing
        objRS1 = Nothing
    End Sub
End Class









































